import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, KeyValueDiffers, Input, Output, NgModule } from '@angular/core';
import { __values } from 'tslib';
import * as moment_ from 'moment';
import { saveAs } from 'file-saver';
import { utils, write } from 'xlsx';
import { FormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularTreeTableService = /** @class */ (function () {
    function AngularTreeTableService() {
    }
    AngularTreeTableService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AngularTreeTableService.ctorParameters = function () { return []; };
    /** @nocollapse */ AngularTreeTableService.ngInjectableDef = ɵɵdefineInjectable({ factory: function AngularTreeTableService_Factory() { return new AngularTreeTableService(); }, token: AngularTreeTableService, providedIn: "root" });
    return AngularTreeTableService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TreeTableRow = /** @class */ (function () {
    function TreeTableRow(id, data, expandable, children) {
        this.id = null;
        this.data = {};
        this.expandable = false;
        this.children = null;
        this.expanded = false;
        // Clickables Context for Actions
        this.clickablesContext = null;
        // Clickable Properties and Actions
        this.clickables = {};
        this.styles = {};
        this.classes = {};
        // Actions Header Buttons
        this.actions = [];
        // Is row selected
        this.selected = false;
        this.id = id;
        this.data = data;
        this.expandable = expandable;
        this.children = children;
    }
    return TreeTableRow;
}());
if (false) {
    /** @type {?} */
    TreeTableRow.prototype.id;
    /** @type {?} */
    TreeTableRow.prototype.data;
    /** @type {?} */
    TreeTableRow.prototype.expandable;
    /** @type {?} */
    TreeTableRow.prototype.children;
    /** @type {?} */
    TreeTableRow.prototype.expanded;
    /** @type {?} */
    TreeTableRow.prototype.clickablesContext;
    /** @type {?} */
    TreeTableRow.prototype.clickables;
    /** @type {?} */
    TreeTableRow.prototype.styles;
    /** @type {?} */
    TreeTableRow.prototype.classes;
    /** @type {?} */
    TreeTableRow.prototype.actions;
    /** @type {?} */
    TreeTableRow.prototype.selected;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TreeTableData = /** @class */ (function () {
    function TreeTableData(config, serverConfig, http) {
        this.headers = [];
        this.data = [];
        this.isLoading = false;
        this.keyword = null;
        this.page = 1;
        this.pageSize = 10;
        this.lastParams = null;
        this.totalRowsCount = 0;
        this.filteredRowsCount = 0;
        this.splashMessageFlag = false;
        this.splashMessageContent = '';
        this.tokens = [null];
        this.isAllRowsExpanded = false;
        this.serverConfig = {
            url: null,
            excelExportUrl: null,
            method: null,
            paramNames: {
                page: 'page',
                limit: 'limit',
                sort: 'sort',
                search: 'search',
                colSearch: 'colSearch',
                colFilters: 'colFilters',
                pageToken: 'pageToken'
            },
            rowsKey: 'rows',
            totalRowsCountKey: 'totalRowsCount',
            filteredRowsCountKey: 'filteredRowsCount',
            rowUniqueKey: null
        };
        this.config = {
            context: null,
            extraInfos: [],
            columnVisibility: false,
            columnVisibilityDropDown: false,
            visibleColumnFiltersVisibility: false,
            visibleColumnFilters: {},
            showExpandArrows: false,
            fullClassName: 'stacktable table-bordered large-only table table-sm',
            sortAscClassName: 'col-sort col-sort-asc',
            sortDescClassName: 'col-sort col-sort-desc',
            sortNothingClassName: 'col-sort col-sort-nothing',
            customClassName: null,
            showExpandAllArrows: false,
            showExpandAllEmptyChildren: false,
            sortedColumn: {},
            showPageLengthDropdown: true,
            pageSizes: [10, 25, 50, 100],
            level: 0,
            columnFilters: {},
            rowClickablesContext: null,
            rowClickables: {},
            commonSearch: true,
            excelExportButton: false,
            excelExportFileName: 'ExportFile',
            excelExportButtonText: 'Excel Export',
            excelExportAllChildren: true,
            excelExportOnlyExpanded: false,
            events: {
                shouldRowExpand: null,
                rowExpanded: null,
                shouldRowCollapse: null,
                rowCollapsed: null
            }
        };
        this.loadCounter = 0;
        this.http = null;
        this.http = http;
        if (serverConfig !== undefined && serverConfig !== null) {
            if (serverConfig.paramNames === undefined || serverConfig.paramNames === null) {
                serverConfig.paramNames = this.serverConfig.paramNames;
            }
            if (serverConfig.rowsKey === undefined || serverConfig.rowsKey === null) {
                serverConfig.rowsKey = this.serverConfig.rowsKey;
            }
            if (serverConfig.rowUniqueKey === undefined || serverConfig.rowUniqueKey === null) {
                serverConfig.rowUniqueKey = this.serverConfig.rowUniqueKey;
            }
            this.serverConfig = serverConfig;
            this.loadData();
        }
        else {
            // console.log('No Server Properties');
        }
        if (config !== undefined && config !== null) {
            if (config.extraInfos !== undefined && config.extraInfos !== null) {
                this.config.extraInfos = config.extraInfos;
            }
            if (config.context !== undefined && config.context !== null) {
                this.config.context = config.context;
            }
            if (config.showExpandArrows !== undefined && config.showExpandArrows !== null) {
                this.config.showExpandArrows = config.showExpandArrows;
            }
            if (config.events === undefined || config.events === null) {
                config.events = this.config.events;
            }
            else {
                if (config.events.rowExpanded !== undefined
                    && config.events.rowExpanded !== null) {
                    this.config.events.rowExpanded = config.events.rowExpanded;
                }
                if (config.events.rowCollapsed !== undefined
                    && config.events.rowCollapsed !== null) {
                    this.config.events.rowCollapsed = config.events.rowCollapsed;
                }
            }
            if (config.fullClassName !== undefined && config.fullClassName !== null) {
                this.config.fullClassName = config.fullClassName;
            }
            if (config.excelExportFileName !== undefined && config.excelExportFileName !== null) {
                this.config.excelExportFileName = config.excelExportFileName;
            }
            if (config.excelExportButtonText !== undefined && config.excelExportButtonText !== null) {
                this.config.excelExportButtonText = config.excelExportButtonText;
            }
            if (config.sortAscClassName !== undefined && config.sortAscClassName !== null) {
                this.config.sortAscClassName = config.sortAscClassName;
            }
            if (config.sortDescClassName !== undefined && config.sortDescClassName !== null) {
                this.config.sortDescClassName = config.sortDescClassName;
            }
            if (config.sortNothingClassName !== undefined && config.sortNothingClassName !== null) {
                this.config.sortNothingClassName = config.sortNothingClassName;
            }
            if (config.customClassName !== undefined && config.customClassName !== null) {
                this.config.customClassName = config.customClassName;
            }
            if (config.showExpandAllArrows !== undefined && config.showExpandAllArrows !== null) {
                this.config.showExpandAllArrows = config.showExpandAllArrows;
            }
            if (config.showExpandAllEmptyChildren !== undefined && config.showExpandAllEmptyChildren !== null) {
                this.config.showExpandAllEmptyChildren = config.showExpandAllEmptyChildren;
            }
            if (config.showPageLengthDropdown !== undefined && config.showPageLengthDropdown !== null) {
                this.config.showPageLengthDropdown = config.showPageLengthDropdown;
            }
            if (config.columnVisibility !== undefined && config.columnVisibility !== null) {
                this.config.columnVisibility = config.columnVisibility;
            }
            if (config.columnVisibilityDropDown !== undefined && config.columnVisibilityDropDown !== null) {
                this.config.columnVisibilityDropDown = config.columnVisibilityDropDown;
            }
            if (config.visibleColumnFiltersVisibility !== undefined && config.visibleColumnFiltersVisibility !== null) {
                this.config.visibleColumnFiltersVisibility = config.visibleColumnFiltersVisibility;
            }
            if (config.sortedColumn !== undefined && config.sortedColumn !== null) {
                this.config.sortedColumn = config.sortedColumn;
            }
            if (config.level !== undefined && config.level !== null) {
                this.config.level = config.level;
            }
            if (config.commonSearch !== undefined && config.commonSearch !== null) {
                this.config.commonSearch = config.commonSearch;
            }
            if (config.columnFilters !== undefined && config.columnFilters !== null) {
                this.config.columnFilters = config.columnFilters;
            }
            if (config.pageSizes !== undefined && config.pageSizes !== null && config.pageSizes.length > 0) {
                this.config.pageSizes.splice(0, this.config.pageSizes.length);
                for (var p = 0; p < config.pageSizes.length; p++) {
                    if (config.pageSizes[p] > 0) {
                        this.config.pageSizes.push(config.pageSizes[p]);
                    }
                }
                // this.config.pageSizes = config.pageSizes;
            }
            if (config.visibleColumnFilters !== undefined && config.visibleColumnFilters !== null) {
                this.config.visibleColumnFilters = config.visibleColumnFilters;
            }
            if (config.rowClickablesContext !== undefined && config.rowClickablesContext !== null) {
                this.config.rowClickablesContext = config.rowClickablesContext;
            }
            if (config.rowClickables !== undefined && config.rowClickables !== null) {
                this.config.rowClickables = config.rowClickables;
            }
            if (config.commonSearch !== undefined && config.commonSearch !== null) {
                this.config.commonSearch = config.commonSearch;
            }
            if (config.excelExportButton !== undefined && config.excelExportButton !== null) {
                this.config.excelExportButton = config.excelExportButton;
            }
        }
        else {
            // console.log('No Properties');
        }
        // console.log('Properties', config);
    }
    /**
     * @return {?}
     */
    TreeTableData.prototype.totalPagesCount = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var pages = this.filteredRowsCount / this.pageSize;
        return Math.ceil(pages);
    };
    /**
     * @return {?}
     */
    TreeTableData.prototype.getParams = /**
     * @return {?}
     */
    function () {
        var e_1, _a;
        /** @type {?} */
        var params = {};
        if (this.page - 1 >= 0) {
            if (this.tokens[this.page - 1] !== undefined && this.tokens[this.page - 1] !== null) {
                params[this.serverConfig.paramNames.pageToken] = this.tokens[this.page - 1];
            }
        }
        params[this.serverConfig.paramNames.page] = this.page;
        params[this.serverConfig.paramNames.search] = this.keyword;
        params[this.serverConfig.paramNames.limit] = this.pageSize;
        params[this.serverConfig.paramNames.colFilters] = JSON.stringify(this.config.columnFilters);
        params[this.serverConfig.paramNames.sort] = JSON.stringify(this.config.sortedColumn);
        /** @type {?} */
        var colSearchKeys = Object.keys(this.config.visibleColumnFilters);
        try {
            for (var colSearchKeys_1 = __values(colSearchKeys), colSearchKeys_1_1 = colSearchKeys_1.next(); !colSearchKeys_1_1.done; colSearchKeys_1_1 = colSearchKeys_1.next()) {
                var key = colSearchKeys_1_1.value;
                if (this.config.visibleColumnFilters[key] === null) {
                    delete this.config.visibleColumnFilters[key];
                }
                if (this.config.visibleColumnFilters[key] === undefined) {
                    delete this.config.visibleColumnFilters[key];
                }
                if (this.config.visibleColumnFilters[key] === '') {
                    delete this.config.visibleColumnFilters[key];
                }
                if (this.config.visibleColumnFilters[key].trim() === '') {
                    delete this.config.visibleColumnFilters[key];
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (colSearchKeys_1_1 && !colSearchKeys_1_1.done && (_a = colSearchKeys_1.return)) _a.call(colSearchKeys_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        params[this.serverConfig.paramNames.colSearch] = JSON.stringify(this.config.visibleColumnFilters);
        return params;
    };
    /**
     * @param {?=} callback
     * @return {?}
     */
    TreeTableData.prototype.loadExcelData = /**
     * @param {?=} callback
     * @return {?}
     */
    function (callback) {
        console.log('Excel Export Clicked');
        if (this.serverConfig.excelExportUrl === null) {
            console.log('ExcelExportUrl not specified');
            return;
        }
        /** @type {?} */
        var params = this.getParams();
        // delete params[this.serverConfig.paramNames.limit];
        /** @type {?} */
        var dis = this;
        dis.isLoading = true;
        if (this.serverConfig.method === 'GET') {
            this.http.get(this.serverConfig.excelExportUrl, { params: params, responseType: 'blob' }).subscribe((/**
             * @param {?} resp
             * @return {?}
             */
            function (resp) {
                dis.isLoading = false;
                /** @type {?} */
                var blob = new Blob([resp], { type: 'application/vnd.ms-excel' });
                saveAs(blob, 'Orders.xlsx');
            }));
        }
    };
    /**
     * @param {?=} callback
     * @return {?}
     */
    TreeTableData.prototype.loadData = /**
     * @param {?=} callback
     * @return {?}
     */
    function (callback) {
        var _this = this;
        if (this.serverConfig.url === null) {
            console.log('URL not specified');
            return;
        }
        /** @type {?} */
        var params = this.getParams();
        if (this.lastParams !== undefined && this.lastParams !== null) {
            if (this.lastParams === JSON.stringify(params)) {
                return;
            }
        }
        this.lastParams = JSON.stringify(params);
        /** @type {?} */
        var dis = this;
        dis.isLoading = true;
        dis.loadCounter++;
        if (this.serverConfig.method === 'GET') {
            this.http.get(this.serverConfig.url, { params: params }).subscribe((/**
             * @param {?} resp
             * @return {?}
             */
            function (resp) {
                var e_2, _a;
                if (callback !== undefined && callback !== null) {
                    /** @type {?} */
                    var rows = [];
                    if (resp[_this.serverConfig.rowsKey] === undefined || resp[_this.serverConfig.rowsKey] === null) {
                        callback([]);
                        dis.loadCounter--;
                        if (dis.loadCounter <= 0) {
                            dis.isLoading = false;
                            dis.loadCounter = 0;
                        }
                    }
                    else {
                        _this.totalRowsCount = 5100; // resp[this.serverConfig.totalRowsCountKey];
                        _this.filteredRowsCount = 5100; // resp[this.serverConfig.filteredRowsCountKey];
                        try {
                            for (var _b = __values(resp[_this.serverConfig.rowsKey]), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var rawRow = _c.value;
                                /** @type {?} */
                                var uniqueVal = null;
                                if (_this.serverConfig.rowUniqueKey === undefined || _this.serverConfig.rowUniqueKey === null) {
                                    uniqueVal = new Date().getTime();
                                }
                                else {
                                    uniqueVal = rawRow[_this.serverConfig.rowUniqueKey];
                                }
                                /** @type {?} */
                                var row = new TreeTableRow(uniqueVal, rawRow, false, undefined);
                                row.clickablesContext = _this.config.rowClickablesContext;
                                row.clickables = _this.config.rowClickables;
                                rows.push(row);
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        /** @type {?} */
                        var lastRawRow = resp[_this.serverConfig.rowsKey][resp[_this.serverConfig.rowsKey].length - 1];
                        if (lastRawRow !== undefined && lastRawRow !== null) {
                            if (_this.serverConfig.rowUniqueKey !== undefined && _this.serverConfig.rowUniqueKey !== null) {
                                _this.tokens[_this.page] = lastRawRow[_this.serverConfig.rowUniqueKey];
                            }
                        }
                        callback(rows);
                        dis.loadCounter--;
                        if (dis.loadCounter <= 0) {
                            dis.isLoading = false;
                            dis.loadCounter = 0;
                        }
                    }
                }
                else {
                    dis.loadCounter--;
                    if (dis.loadCounter <= 0) {
                        dis.isLoading = false;
                        dis.loadCounter = 0;
                    }
                }
            }), (/**
             * @param {?} err
             * @return {?}
             */
            function (err) {
                dis.loadCounter--;
                if (dis.loadCounter <= 0) {
                    dis.isLoading = false;
                    dis.loadCounter = 0;
                }
            }));
        }
    };
    /**
     * @return {?}
     */
    TreeTableData.prototype.allRowsExpanded = /**
     * @return {?}
     */
    function () {
        return false;
    };
    /**
     * @return {?}
     */
    TreeTableData.prototype.allRowsCollapsed = /**
     * @return {?}
     */
    function () {
        return false;
    };
    /**
     * @param {?} msg
     * @return {?}
     */
    TreeTableData.prototype.splashMessage = /**
     * @param {?} msg
     * @return {?}
     */
    function (msg) {
        this.splashMessageContent = msg;
        this.splashMessageFlag = true;
        /** @type {?} */
        var dis = this;
        setTimeout((/**
         * @return {?}
         */
        function () {
            dis.splashMessageFlag = false;
        }), 2000);
    };
    return TreeTableData;
}());
if (false) {
    /** @type {?} */
    TreeTableData.prototype.headers;
    /** @type {?} */
    TreeTableData.prototype.data;
    /** @type {?} */
    TreeTableData.prototype.isLoading;
    /** @type {?} */
    TreeTableData.prototype.keyword;
    /** @type {?} */
    TreeTableData.prototype.page;
    /** @type {?} */
    TreeTableData.prototype.pageSize;
    /** @type {?} */
    TreeTableData.prototype.lastParams;
    /** @type {?} */
    TreeTableData.prototype.totalRowsCount;
    /** @type {?} */
    TreeTableData.prototype.filteredRowsCount;
    /** @type {?} */
    TreeTableData.prototype.splashMessageFlag;
    /** @type {?} */
    TreeTableData.prototype.splashMessageContent;
    /** @type {?} */
    TreeTableData.prototype.tokens;
    /** @type {?} */
    TreeTableData.prototype.isAllRowsExpanded;
    /** @type {?} */
    TreeTableData.prototype.serverConfig;
    /** @type {?} */
    TreeTableData.prototype.config;
    /** @type {?} */
    TreeTableData.prototype.loadCounter;
    /**
     * @type {?}
     * @private
     */
    TreeTableData.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var TtDataType = {
    NUMBER: 'NUMBER',
    TEXT: 'TEXT',
    DATE: 'DATE',
    ACTIONS: 'ACTIONS',
    SELECT: 'SELECT',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var TreeTableRowActionType = {
    BUTTON: 0, LINK: 1, TOGGLE_CHILD: 2, TOGGLE_SELECT: 3,
};
TreeTableRowActionType[TreeTableRowActionType.BUTTON] = 'BUTTON';
TreeTableRowActionType[TreeTableRowActionType.LINK] = 'LINK';
TreeTableRowActionType[TreeTableRowActionType.TOGGLE_CHILD] = 'TOGGLE_CHILD';
TreeTableRowActionType[TreeTableRowActionType.TOGGLE_SELECT] = 'TOGGLE_SELECT';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var moment = moment_;
var AngularTreeTableComponent = /** @class */ (function () {
    function AngularTreeTableComponent(differs) {
        this.differs = differs;
        this.tableData = new TreeTableData();
        this.filteredData = [];
        this.className = '';
        this.randomInstance = null;
        this.dropdownHideListenerAdded = false;
        this.currentPageData = new TreeTableData();
        this.json = null;
        this.extraInfoItemWidthPercent = 100;
        this.rowSelectionChanged = new EventEmitter();
        this.json = JSON;
    }
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.validateData();
        this.setPageData(this.tableData.page);
        this.className = 'table-tree level' + this.tableData.config.level;
        if (this.tableData.config.level === 0) {
            console.warn('Initialize Search Functionality');
        }
        this.dataDiffers = this.differs.find(this.tableData).create();
        this.columnFiltersDiffers = this.differs.find(this.tableData.config.columnFilters).create();
        this.randomInstance = Math.floor(Math.random() * Math.floor(9999));
        this.extraInfoItemWidthPercent = 100 / this.tableData.config.extraInfos.length;
        this.redefineTableDataFunctions();
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.redefineTableDataFunctions = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var dis = this;
        this.tableData.allRowsCollapsed = (/**
         * @return {?}
         */
        function () {
            return dis.currentPageData.data.length === dis.currentPageData.data.filter((/**
             * @param {?} v
             * @return {?}
             */
            function (v) { return !v.expanded; })).length;
        });
        this.tableData.allRowsExpanded = (/**
         * @return {?}
         */
        function () {
            return dis.currentPageData.data.length === dis.currentPageData.data.filter((/**
             * @param {?} v
             * @return {?}
             */
            function (v) { return v.expanded; })).length;
        });
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    AngularTreeTableComponent.prototype.dataChanged = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        this.redefineTableDataFunctions();
        this.setPageData(this.tableData.page);
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.refreshTable = /**
     * @return {?}
     */
    function () {
        this.setPageData(this.tableData.page);
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.ngDoCheck = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var changes = this.dataDiffers.diff(this.tableData);
        if (changes) {
            this.dataChanged(changes);
        }
        changes = this.columnFiltersDiffers.diff(this.tableData.config.columnFilters);
        if (changes) {
            this.dataChanged(changes);
        }
        if (!this.dropdownHideListenerAdded) {
            console.log('#dropDownVisCon' + this.randomInstance);
            $('#dropDownVisCon' + this.randomInstance).on('hide.bs.dropdown', (/**
             * @param {?} e
             * @return {?}
             */
            function (e) {
                if (e.clickEvent !== undefined) {
                    if ($(e.clickEvent.target).hasClass('btnVis')) {
                        return false;
                    }
                }
                this.dropdownHideListenerAdded = true;
                return true;
            }));
        }
    };
    /**
     * @param {?} row
     * @return {?}
     */
    AngularTreeTableComponent.prototype.expandRow = /**
     * @param {?} row
     * @return {?}
     */
    function (row) {
        row.expanded = true;
        if (this.tableData.config.events.rowExpanded !== null) {
            this.tableData.config.events.rowExpanded(row, this.tableData);
        }
    };
    /**
     * @param {?} row
     * @return {?}
     */
    AngularTreeTableComponent.prototype.collapseRow = /**
     * @param {?} row
     * @return {?}
     */
    function (row) {
        row.expanded = false;
        this.tableData.isAllRowsExpanded = false;
        if (this.tableData.config.events.rowCollapsed !== null) {
            this.tableData.config.events.rowCollapsed(row, this.tableData);
        }
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.expandAllRows = /**
     * @return {?}
     */
    function () {
        this.expandAllRowsInData(this.currentPageData.data);
        this.tableData.isAllRowsExpanded = true;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AngularTreeTableComponent.prototype.expandAllRowsInData = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        var e_1, _a;
        try {
            for (var data_1 = __values(data), data_1_1 = data_1.next(); !data_1_1.done; data_1_1 = data_1.next()) {
                var row = data_1_1.value;
                if (row.expandable) {
                    if (row.children !== null) {
                        if (row.children.data !== null) {
                            if (this.tableData.config.showExpandAllEmptyChildren) {
                                // row.expanded = true;
                                this.expandRow(row);
                                this.expandAllRowsInData(row.children.data);
                                row.children.isAllRowsExpanded = true;
                            }
                            else {
                                if (row.children.data.length > 0) {
                                    // row.expanded = true;
                                    this.expandRow(row);
                                    this.expandAllRowsInData(row.children.data);
                                    row.children.isAllRowsExpanded = true;
                                }
                            }
                        }
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (data_1_1 && !data_1_1.done && (_a = data_1.return)) _a.call(data_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.collapseAllRows = /**
     * @return {?}
     */
    function () {
        this.collapseAllRowsInData(this.currentPageData.data);
        this.tableData.isAllRowsExpanded = false;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AngularTreeTableComponent.prototype.collapseAllRowsInData = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        var e_2, _a;
        try {
            for (var data_2 = __values(data), data_2_1 = data_2.next(); !data_2_1.done; data_2_1 = data_2.next()) {
                var row = data_2_1.value;
                if (row.expandable) {
                    if (row.children !== null) {
                        if (row.children.data !== null) {
                            if (this.tableData.config.showExpandAllEmptyChildren) {
                                // row.expanded = false;
                                this.collapseRow(row);
                                this.collapseAllRowsInData(row.children.data);
                                row.children.isAllRowsExpanded = false;
                            }
                            else {
                                if (row.children.data.length > 0) {
                                    // row.expanded = false;
                                    this.collapseRow(row);
                                    this.collapseAllRowsInData(row.children.data);
                                    row.children.isAllRowsExpanded = false;
                                }
                            }
                        }
                    }
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (data_2_1 && !data_2_1.done && (_a = data_2.return)) _a.call(data_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    /**
     * @param {?} row
     * @return {?}
     */
    AngularTreeTableComponent.prototype.toggleRow = /**
     * @param {?} row
     * @return {?}
     */
    function (row) {
        row.expanded ? this.collapseRow(row) : this.expandRow(row);
    };
    /**
     * @param {?} row
     * @param {?} action
     * @return {?}
     */
    AngularTreeTableComponent.prototype.rowAction = /**
     * @param {?} row
     * @param {?} action
     * @return {?}
     */
    function (row, action) {
        if (action.type === TreeTableRowActionType.TOGGLE_CHILD) {
            this.toggleRow(row);
        }
        if (action.action !== undefined && action.action !== null) {
            action.action.bind(action.context, row.data)();
        }
    };
    /**
     * @param {?} page
     * @return {?}
     */
    AngularTreeTableComponent.prototype.changePage = /**
     * @param {?} page
     * @return {?}
     */
    function (page) {
        if (this.tableData.page === page || page < 1) {
            return;
        }
        if (page > this.tableData.totalPagesCount()) {
            return;
        }
        // if (this.currentPageData.data.length < this.tableData.pageSize && this.tableData.page < page) {
        //   this.tableData.splashMessage('Reached last page');
        //   return;
        // }
        this.setPageData(page);
        this.collapseAllRows();
    };
    /**
     * @param {?} pageNumber
     * @return {?}
     */
    AngularTreeTableComponent.prototype.setPageData = /**
     * @param {?} pageNumber
     * @return {?}
     */
    function (pageNumber) {
        var _this = this;
        this.extraInfoItemWidthPercent = 100 / this.tableData.config.extraInfos.length;
        /** @type {?} */
        var dis = this;
        if (this.tableData.serverConfig.url !== undefined && this.tableData.serverConfig.url !== null) {
            if (pageNumber !== 1) {
                if ((pageNumber - 1) * this.tableData.pageSize > this.tableData.totalRowsCount) {
                    console.warn('Invalid Page', (pageNumber - 1) * this.tableData.pageSize, this.tableData.totalRowsCount);
                    return;
                }
            }
            this.tableData.page = pageNumber;
            this.tableData.loadData((/**
             * @param {?} rows
             * @return {?}
             */
            function (rows) {
                var e_3, _a;
                // if (rows.length === 0) {
                //   dis.changePage(dis.tableData.page - 1);
                //   dis.tableData.splashMessage('Reached last page');
                //   console.warn('No data on the next page');
                //   // return;
                // }
                dis.filteredData.splice(0, _this.filteredData.length);
                try {
                    for (var rows_1 = __values(rows), rows_1_1 = rows_1.next(); !rows_1_1.done; rows_1_1 = rows_1.next()) {
                        var row = rows_1_1.value;
                        dis.filteredData.push(row);
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (rows_1_1 && !rows_1_1.done && (_a = rows_1.return)) _a.call(rows_1);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
                /** @type {?} */
                var rowsCount = dis.filteredData.length;
                // dis.tableData.pagesCount = Math.floor(rowsCount / this.tableData.pageSize);
                // if (dis.tableData.pageSize * dis.tableData.pagesCount < rowsCount) {
                //   dis.tableData.pagesCount++;
                // }
                dis.currentPageData.headers = dis.tableData.headers;
                /** @type {?} */
                var startIndex = (pageNumber - 1) * _this.tableData.pageSize;
                if (_this.currentPageData.data === undefined) {
                    _this.currentPageData.data = [];
                }
                _this.currentPageData.data.splice(0, _this.currentPageData.data.length);
                for (var i = 0; i < parseInt(_this.tableData.pageSize + '', 10); i++) {
                    // console.log('Adding Vvalue', this.filteredData[i], i);
                    if (_this.filteredData[i] !== null && _this.filteredData[i] !== undefined) {
                        _this.currentPageData.data.push(_this.filteredData[i]);
                    }
                }
            }));
        }
        else {
            dis.tableData.totalRowsCount = dis.tableData.data.length;
            if (pageNumber !== 1) {
                if ((pageNumber - 1) * this.tableData.pageSize > this.tableData.totalRowsCount) {
                    console.warn('Invalid Page', (pageNumber - 1) * this.tableData.pageSize, this.tableData.totalRowsCount);
                    return;
                }
            }
            this.tableData.page = pageNumber;
            this.filteredData.splice(0, this.filteredData.length);
            this.filteredData = this.tableData.data.filter((/**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                var e_4, _a, e_5, _b, e_6, _c, e_7, _d;
                /** @type {?} */
                var keys = Object.keys(v.data);
                /** @type {?} */
                var matched = false;
                if (_this.tableData.keyword !== undefined && _this.tableData.keyword !== null && _this.tableData.keyword.trim() !== '') {
                    try {
                        for (var keys_1 = __values(keys), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
                            var key = keys_1_1.value;
                            if (v.data[key] === undefined || v.data[key] === null) {
                                continue;
                            }
                            matched = v.data[key].toString().toLowerCase().indexOf(_this.tableData.keyword.toLowerCase()) > -1;
                            if (matched) {
                                break;
                            }
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                }
                else {
                    matched = true;
                }
                if (matched && _this.tableData.config.columnFilters !== undefined && _this.tableData.config.columnFilters !== null) {
                    try {
                        for (var keys_2 = __values(keys), keys_2_1 = keys_2.next(); !keys_2_1.done; keys_2_1 = keys_2.next()) {
                            var key = keys_2_1.value;
                            if (_this.tableData.config.columnFilters[key] !== undefined &&
                                _this.tableData.config.columnFilters[key] !== null &&
                                Array.isArray(_this.tableData.config.columnFilters[key])) {
                                if (v.data[key] === undefined || v.data[key] === null) {
                                    matched = false;
                                    break;
                                }
                                /** @type {?} */
                                var orMatch = false;
                                try {
                                    for (var _e = (e_6 = void 0, __values(_this.tableData.config.columnFilters[key])), _f = _e.next(); !_f.done; _f = _e.next()) {
                                        var orFilter = _f.value;
                                        orMatch = v.data[key].toString().toLowerCase().indexOf(orFilter.toLowerCase()) > -1;
                                        if (orMatch) {
                                            break;
                                        }
                                    }
                                }
                                catch (e_6_1) { e_6 = { error: e_6_1 }; }
                                finally {
                                    try {
                                        if (_f && !_f.done && (_c = _e.return)) _c.call(_e);
                                    }
                                    finally { if (e_6) throw e_6.error; }
                                }
                                matched = orMatch;
                                if (!matched) {
                                    break;
                                }
                            }
                        }
                    }
                    catch (e_5_1) { e_5 = { error: e_5_1 }; }
                    finally {
                        try {
                            if (keys_2_1 && !keys_2_1.done && (_b = keys_2.return)) _b.call(keys_2);
                        }
                        finally { if (e_5) throw e_5.error; }
                    }
                }
                if (matched && _this.tableData.config.visibleColumnFilters !== undefined && _this.tableData.config.visibleColumnFilters !== null) {
                    try {
                        for (var keys_3 = __values(keys), keys_3_1 = keys_3.next(); !keys_3_1.done; keys_3_1 = keys_3.next()) {
                            var key = keys_3_1.value;
                            if (_this.tableData.config.visibleColumnFilters[key] !== undefined &&
                                _this.tableData.config.visibleColumnFilters[key] !== null &&
                                _this.tableData.config.visibleColumnFilters[key].trim() !== '') {
                                if (v.data[key] === undefined || v.data[key] === null) {
                                    matched = false;
                                    break;
                                }
                                matched = v.data[key].toString().toLowerCase().indexOf(_this.tableData.config.visibleColumnFilters[key].toLowerCase()) > -1;
                                if (!matched) {
                                    break;
                                }
                            }
                        }
                    }
                    catch (e_7_1) { e_7 = { error: e_7_1 }; }
                    finally {
                        try {
                            if (keys_3_1 && !keys_3_1.done && (_d = keys_3.return)) _d.call(keys_3);
                        }
                        finally { if (e_7) throw e_7.error; }
                    }
                }
                return matched;
            }));
            /** @type {?} */
            var rowsCount = dis.filteredData.length;
            dis.tableData.filteredRowsCount = rowsCount;
            // dis.tableData.pagesCount = Math.floor(rowsCount / this.tableData.pageSize);
            // if (dis.tableData.pageSize * dis.tableData.pagesCount < rowsCount) {
            //   dis.tableData.pagesCount++;
            // }
            dis.currentPageData.headers = dis.tableData.headers;
            /** @type {?} */
            var startIndex = (pageNumber - 1) * this.tableData.pageSize;
            if (this.currentPageData.data === undefined) {
                this.currentPageData.data = [];
            }
            this.currentPageData.data.splice(0, this.currentPageData.data.length);
            for (var i = startIndex; i < parseInt(startIndex + '', 10) + parseInt(this.tableData.pageSize + '', 10); i++) {
                if (this.filteredData[i] !== null && this.filteredData[i] !== undefined) {
                    this.currentPageData.data.push(this.filteredData[i]);
                }
            }
        }
    };
    /**
     * @param {?} row
     * @param {?} dataProperty
     * @return {?}
     */
    AngularTreeTableComponent.prototype.clickableClicked = /**
     * @param {?} row
     * @param {?} dataProperty
     * @return {?}
     */
    function (row, dataProperty) {
        if (typeof row.clickables[dataProperty] === 'string') {
            if (row.clickables[dataProperty] === TreeTableRowActionType.TOGGLE_CHILD.toString()) {
                this.toggleRow(row);
                return;
            }
        }
        if (row.clickablesContext !== null) {
            row.clickables[dataProperty].bind(row.clickablesContext, row.data)();
        }
        else {
            row.clickables[dataProperty](row.data);
        }
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.validateData = /**
     * @return {?}
     */
    function () {
        console.warn('Data Schema need to be validated');
    };
    /**
     * @param {?} dataProperty
     * @return {?}
     */
    AngularTreeTableComponent.prototype.columnSearchChanged = /**
     * @param {?} dataProperty
     * @return {?}
     */
    function (dataProperty) {
        this.setPageData(1);
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.pageNumbers = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var pageNumbers = [];
        /** @type {?} */
        var limit = 2;
        /** @type {?} */
        var maxLimit = 4;
        for (var p = this.tableData.page - limit; p < this.tableData.page; p++) {
            if (p > 0) {
                pageNumbers.push(p);
            }
        }
        /** @type {?} */
        var unfilledCount = limit - pageNumbers.length;
        for (var q = this.tableData.page; q <= this.tableData.page + unfilledCount + limit; q++) {
            if (q <= this.tableData.totalPagesCount()) {
                pageNumbers.push(q);
            }
        }
        if (pageNumbers.length < maxLimit) {
            for (var p = this.tableData.page - limit * 2; p < this.tableData.page - limit; p++) {
                if (p > 0) {
                    pageNumbers.unshift(p);
                }
            }
        }
        return pageNumbers;
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.exportExcelLocal = /**
     * @return {?}
     */
    function () {
        var e_8, _a, e_9, _b;
        /** @type {?} */
        var dataRows = [];
        try {
            for (var _c = __values(this.tableData.data), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                /** @type {?} */
                var obj = {};
                try {
                    for (var _e = (e_9 = void 0, __values(this.tableData.headers)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var h = _f.value;
                        obj[h.title] = d.data[h.dataProperty];
                    }
                }
                catch (e_9_1) { e_9 = { error: e_9_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                    }
                    finally { if (e_9) throw e_9.error; }
                }
                dataRows.push(obj);
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_8) throw e_8.error; }
        }
        /** @type {?} */
        var fileType = 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet;charset=UTF-8';
        /** @type {?} */
        var fileExtension = '.xlsx';
        /** @type {?} */
        var ws = utils.json_to_sheet(dataRows);
        /** @type {?} */
        var wb = { Sheets: { data: ws }, SheetNames: ['data'] };
        /** @type {?} */
        var excelBuffer = write(wb, { bookType: 'xlsx', type: 'array' });
        /** @type {?} */
        var data = new Blob([excelBuffer], { type: fileType });
        saveAs(data, this.tableData.config.excelExportFileName + fileExtension);
    };
    /**
     * @param {?} header
     * @return {?}
     */
    AngularTreeTableComponent.prototype.sortColumn = /**
     * @param {?} header
     * @return {?}
     */
    function (header) {
        /** @type {?} */
        var propertyName = header.dataProperty;
        if (this.tableData.config.sortedColumn[propertyName] === undefined) {
            this.tableData.config.sortedColumn = {};
            this.tableData.config.sortedColumn[propertyName] = 'DESC';
            this.sortDescend(header);
        }
        else if (this.tableData.config.sortedColumn[propertyName] === 'DESC') {
            this.tableData.config.sortedColumn[propertyName] = 'ASC';
            this.sortAscend(header);
        }
        else {
            delete this.tableData.config.sortedColumn[propertyName];
        }
    };
    /**
     * @param {?} header
     * @return {?}
     */
    AngularTreeTableComponent.prototype.sortAscend = /**
     * @param {?} header
     * @return {?}
     */
    function (header) {
        /** @type {?} */
        var propertyName = header.dataProperty;
        if (header.dataType === TtDataType.NUMBER) {
            this.tableData.data.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) {
                if (parseFloat(a.data[propertyName]) < parseFloat(b.data[propertyName])) {
                    return -1;
                }
                else if (parseFloat(a.data[propertyName]) > parseFloat(b.data[propertyName])) {
                    return 1;
                }
                return 0;
            }));
        }
        else if (header.dataType === TtDataType.DATE) {
            this.tableData.data.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) {
                if (moment(a.data[propertyName]).toDate().getTime() < moment(b.data[propertyName]).toDate().getTime()) {
                    return -1;
                }
                else if (moment(a.data[propertyName]).toDate().getTime() > moment(b.data[propertyName]).toDate().getTime()) {
                    return 1;
                }
                return 0;
            }));
        }
        else {
            this.tableData.data.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) {
                if (a.data[propertyName] < b.data[propertyName]) {
                    return -1;
                }
                else if (a.data[propertyName] > b.data[propertyName]) {
                    return 1;
                }
                return 0;
            }));
        }
        this.setPageData(this.tableData.page);
    };
    /**
     * @param {?} header
     * @return {?}
     */
    AngularTreeTableComponent.prototype.sortDescend = /**
     * @param {?} header
     * @return {?}
     */
    function (header) {
        /** @type {?} */
        var propertyName = header.dataProperty;
        if (header.dataType === TtDataType.NUMBER) {
            this.tableData.data.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) {
                if (parseFloat(a.data[propertyName]) < parseFloat(b.data[propertyName])) {
                    return 1;
                }
                else if (parseFloat(a.data[propertyName]) > parseFloat(b.data[propertyName])) {
                    return -1;
                }
                return 0;
            }));
        }
        else if (header.dataType === TtDataType.DATE) {
            this.tableData.data.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) {
                if (moment(a.data[propertyName]).toDate().getTime() < moment(b.data[propertyName]).toDate().getTime()) {
                    return 1;
                }
                else if (moment(a.data[propertyName]).toDate().getTime() > moment(b.data[propertyName]).toDate().getTime()) {
                    return -1;
                }
                return 0;
            }));
        }
        else {
            this.tableData.data.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) {
                if (a.data[propertyName] < b.data[propertyName]) {
                    return 1;
                }
                else if (a.data[propertyName] > b.data[propertyName]) {
                    return -1;
                }
                return 0;
            }));
        }
        this.setPageData(this.tableData.page);
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.search = /**
     * @return {?}
     */
    function () {
        this.setPageData(1);
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.pageSizeChanged = /**
     * @return {?}
     */
    function () {
        this.setPageData(1);
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.excelExportClicked = /**
     * @return {?}
     */
    function () {
        if (this.tableData.serverConfig !== undefined && this.tableData.serverConfig !== null && this.tableData.serverConfig.excelExportUrl !== undefined && this.tableData.serverConfig.excelExportUrl !== null) {
            this.tableData.loadExcelData();
        }
        else {
            this.exportExcelLocal();
        }
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.getPageTo = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var to = this.tableData.pageSize * this.tableData.page;
        if (to > this.tableData.filteredRowsCount) {
            to = this.tableData.filteredRowsCount;
        }
        return to;
    };
    /**
     * @param {?} header
     * @return {?}
     */
    AngularTreeTableComponent.prototype.isAllRowsSelected = /**
     * @param {?} header
     * @return {?}
     */
    function (header) {
        return this.tableData.data.filter((/**
         * @param {?} v
         * @return {?}
         */
        function (v) { return v.selected; })).length === this.tableData.data.length;
    };
    /**
     * @param {?} header
     * @return {?}
     */
    AngularTreeTableComponent.prototype.toggleSelectAllRows = /**
     * @param {?} header
     * @return {?}
     */
    function (header) {
        this.isAllRowsSelected(header) ? this.deselectAllRows(header) : this.selectAllRows(header);
    };
    /**
     * @private
     * @param {?} header
     * @return {?}
     */
    AngularTreeTableComponent.prototype.selectAllRows = /**
     * @private
     * @param {?} header
     * @return {?}
     */
    function (header) {
        this.tableData.data = this.tableData.data.map((/**
         * @param {?} v
         * @return {?}
         */
        function (v) { v.selected = true; return v; }));
        this.updateHost();
    };
    /**
     * @private
     * @param {?} header
     * @return {?}
     */
    AngularTreeTableComponent.prototype.deselectAllRows = /**
     * @private
     * @param {?} header
     * @return {?}
     */
    function (header) {
        this.tableData.data = this.tableData.data.map((/**
         * @param {?} v
         * @return {?}
         */
        function (v) { v.selected = false; return v; }));
        this.updateHost();
    };
    /**
     * @param {?} row
     * @return {?}
     */
    AngularTreeTableComponent.prototype.toggleSelectRow = /**
     * @param {?} row
     * @return {?}
     */
    function (row) {
        row.selected = !row.selected;
        this.updateHost();
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.getSelectedRows = /**
     * @return {?}
     */
    function () {
        return this.tableData.data.filter((/**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            if (v.selected) {
                return v.data;
            }
        }));
    };
    /**
     * @return {?}
     */
    AngularTreeTableComponent.prototype.updateHost = /**
     * @return {?}
     */
    function () {
        if (this.rowSelectionChanged !== undefined && this.rowSelectionChanged !== null) {
            this.rowSelectionChanged.emit(this.getSelectedRows());
        }
    };
    AngularTreeTableComponent.decorators = [
        { type: Component, args: [{
                    selector: 'angular-tree-table',
                    template: "<div class=\"tree-table\">\n  <div class=\"tree-table-loading\" [ngClass]=\"tableData.isLoading ? 'on' : 'off'\">\n    <div class=\"loader-msg\">\n      Loading...\n    </div>\n  </div>\n  <div class=\"action-container\">\n    <div class=\"search-section\" *ngIf=\"tableData.config.showPageLengthDropdown || tableData.config.commonSearch || tableData.config.excelExportButton\">\n      <div class=\"first-part\" *ngIf=\"tableData.config.showPageLengthDropdown\">\n        Show <select class=\"select-page-size form-control form-control-sm\" [(ngModel)]=\"tableData.pageSize\"\n          (change)=\"pageSizeChanged()\">\n          <option value=\"{{p}}\" *ngFor=\"let p of tableData.config.pageSizes\">{{p}}</option>\n        </select> Entries\n      </div>\n      <div class=\"second-part\">\n        <input *ngIf=\"tableData.config.commonSearch\" type=\"text\"\n          class=\"form-control form-control-sm text-center col-3 float-right\" [(ngModel)]=\"tableData.keyword\"\n          (keyup)=\"search()\" (change)=\"search()\" placeholder=\"Search\" />\n        <button *ngIf=\"tableData.config.excelExportButton\"\n          class=\"btn btn-sm btn-primary export excelExportButton float-right\" (click)=\"excelExportClicked()\">{{tableData.config.excelExportButtonText}}</button>\n        <div class=\"dropdown\" id=\"dropDownVisCon{{randomInstance}}\">\n          <button id=\"dropDownVis{{randomInstance}}\" *ngIf=\"tableData.config.columnVisibilityDropDown\"\n            class=\"btn btn-sm btn-secondary dropDownBtn v-elipses float-right dropdown-toggle\" data-toggle=\"dropdown\"\n            aria-haspopup=\"true\" aria-expanded=\"false\">\u22EE</button>\n            <div class=\"dropDownBtn-data dropdown-menu\">\n              <button class=\"btnVis btn-sm btn\" *ngFor=\"let header of currentPageData.headers\"\n                [ngClass]=\"header.show ? 'active': ''\" (click)=\" header.show = !header.show;\">{{header.title}}</button>\n            </div>\n        </div>\n      </div>\n    </div>\n    <div class=\"buttons-section\" *ngIf=\"tableData.config.columnVisibility\">\n      <div class=\"column-visibility\" *ngIf=\"tableData.config.columnVisibility\">\n        <button class=\"btnVis\" *ngFor=\"let header of currentPageData.headers\" [ngClass]=\"header.show ? 'active': ''\"\n          (click)=\"header.show = !header.show\">{{header.title}}</button>\n      </div>\n    </div>\n    <div class=\"extraInfo-section\" *ngIf=\"tableData.config.extraInfos.length > 0\">\n      <div class=\"extraInfo\" [style.width]=\"extraInfoItemWidthPercent + '%'\" *ngFor=\"let exInfo of tableData.config.extraInfos\">\n        {{exInfo[0]}}: {{exInfo[1]}}\n      </div>\n    </div>\n  </div>\n  <table [class]=\"className + ' ' + tableData.config.customClassName + ' ' + tableData.config.fullClassName\">\n    <thead class=\"ds2-table-element--head-row thead-sm\">\n      <tr>\n        <th *ngIf=\"!tableData.config.showExpandAllArrows\" [ngClass]=\"tableData.config.showExpandArrows ? 'used' : 'not-used'\"></th>\n        <th *ngIf=\"tableData.config.showExpandAllArrows\" [ngClass]=\"tableData.config.showExpandArrows ? 'used' : 'not-used'\">\n          <button class=\"btn btn-secondary btn-sm collapsed-row-button\" (click)=\"expandAllRows()\" \n                      *ngIf=\"!tableData.isAllRowsExpanded\"></button>\n              <button class=\"btn btn-secondary btn-sm expanded-row-button\" (click)=\"collapseAllRows()\" \n                      *ngIf=\"tableData.isAllRowsExpanded\"></button>\n        </th>\n        <ng-container *ngFor=\"let header of currentPageData.headers\">\n          <th *ngIf=\"header.show && header.dataType !== 'SELECT'\" [ngClass]=\"header.style\" (click)=\"sortColumn(header)\">{{header.title}}\n            <i [ngClass]=\"tableData.config.sortAscClassName+' sort-right-align'\" *ngIf=\"tableData.config.sortedColumn[header.dataProperty] === 'ASC'\"></i>\n            <i [ngClass]=\"tableData.config.sortDescClassName+' sort-right-align'\" *ngIf=\"tableData.config.sortedColumn[header.dataProperty] === 'DESC'\"></i>\n            <i [ngClass]=\"tableData.config.sortNothingClassName+' sort-right-align'\" *ngIf=\"tableData.config.sortedColumn[header.dataProperty] !== 'DESC' && tableData.config.sortedColumn[header.dataProperty] !== 'ASC'\"></i>\n          </th>\n          <th *ngIf=\"header.show && header.dataType === 'SELECT'\" [ngClass]=\"header.style\" (click)=\"toggleSelectAllRows(header)\">\n            <input type=\"checkbox\" class=\"header-check-box select-all\" [checked]=\"isAllRowsSelected(header) ? 'checked' : ''\"/> {{header.title}}\n          </th>\n        </ng-container>\n      </tr>\n      <tr *ngIf=\"tableData.config.visibleColumnFiltersVisibility\">\n        <th [ngClass]=\"tableData.config.showExpandArrows ? 'used' : 'not-used'\"></th>\n        <ng-container *ngFor=\"let header of currentPageData.headers\">\n          <th *ngIf=\"header.show\">\n            <input type=\"text\" class=\"form-control form-control-sm text-center\" placeholder=\"{{header.title}}\"\n              (change)=\"columnSearchChanged(header.dataProperty)\" (keyup)=\"columnSearchChanged(header.dataProperty)\"\n              [(ngModel)]=\"tableData.config.visibleColumnFilters[header.dataProperty]\"\n              [disabled]=\"!header.enableColumnSearch || header.dataType === 'SELECT'\" [name]=\"'filter_'+header.dataProperty\" />\n          </th>\n        </ng-container>\n      </tr>\n    </thead>\n    <tbody>\n      <ng-container *ngIf=\"currentPageData.data.length === 0\">\n        <tr *ngIf=\"tableData.isLoading\">\n          <td [ngClass]=\"tableData.config.showExpandArrows ? 'used' : 'not-used'\"></td>\n          <td [attr.colspan]=\"currentPageData.headers.length + 1\" style=\"text-align: center;\">\n            Loading...\n          </td>\n        </tr>\n        <tr *ngIf=\"!tableData.isLoading\">\n          <td [ngClass]=\"tableData.config.showExpandArrows ? 'used' : 'not-used'\"></td>\n          <td [attr.colspan]=\"currentPageData.headers.length + 1\" style=\"text-align: center;\">\n            No records found\n          </td>\n        </tr>\n      </ng-container>\n      <ng-container *ngFor=\"let row of currentPageData.data\">\n        <ng-container *ngIf=\"row !== undefined\">\n          <tr [ngClass]=\"{'expanded-row': row.expanded, 'collapsed-row': !row.expanded, 'selected': 'row.selected', 'unselected': '!row.selected'}\">\n            <td *ngIf=\"!row.expandable\" [ngClass]=\"tableData.config.showExpandArrows ? 'used' : 'not-used'\"></td>\n            <td *ngIf=\"row.expandable\" [ngClass]=\"tableData.config.showExpandArrows ? 'used' : 'not-used'\">\n              <button class=\"btn btn-secondary btn-sm collapsed-row-button\" (click)=\"expandRow(row)\" \n                      *ngIf=\"!row.expanded\"></button>\n              <button class=\"btn btn-secondary btn-sm expanded-row-button\" (click)=\"collapseRow(row)\" \n                      *ngIf=\"row.expanded\"></button>\n            </td>\n            <ng-container *ngFor=\"let header of currentPageData.headers\">\n              <td *ngIf=\"header.show\" [style]=\"row.styles[header.dataProperty]\"\n                [ngClass]=\"row.classes[header.dataProperty]\">\n                <ng-container *ngIf=\"header.dataType === 'ACTIONS'\">\n                  <button class=\"tt-row-action  btn-xs btn btn-default\" *ngFor=\"let action of row.actions\"\n                    [ngClass]=\"action.classes\" (click)=\"rowAction(row, action)\" [title]=\"action.title\">\n                    {{action.label}}\n                  </button>\n                </ng-container>\n                <ng-container *ngIf=\"header.dataType === 'SELECT'\">\n                  <input type=\"checkbox\" class=\"header-check-box select-one\" \n                         [checked]=\"row.selected ? 'checked' : ''\" \n                         (change)=\"toggleSelectRow(row)\"/>\n                </ng-container>\n                <ng-container *ngIf=\"header.dataType !== 'ACTIONS' && header.dataType !== 'SELECT'\">\n                  <ng-container *ngIf=\"row.clickables[header.dataProperty] !== undefined\">\n                    <button class=\"popup-link-button\"\n                      (click)=\"clickableClicked(row, header.dataProperty)\">{{row.data[header.dataProperty]}}</button>\n                  </ng-container>\n                  <ng-container *ngIf=\"row.clickables[header.dataProperty] === undefined\">\n                    {{row.data[header.dataProperty]}}\n                  </ng-container>\n                </ng-container>\n              </td>\n            </ng-container>\n          </tr>\n          <tr *ngIf=\"row.expanded\" [ngClass]=\"row.expanded ? 'expanded-row-content' : 'collapsed-row-content'\">\n            <td style=\"width: 10px;\"></td>\n            <td [colSpan]=\"currentPageData.headers.length\">\n              <angular-tree-table [tableData]=\"row.children\"></angular-tree-table>\n            </td>\n          </tr>\n        </ng-container>\n      </ng-container>\n    </tbody>\n  </table>\n  <div class=\"table-bottom\">\n    <div class=\"page-number-status\">\n      Showing {{(tableData.pageSize * (tableData.page - 1)) + 1}} to {{getPageTo()}} of\n      <ng-container *ngIf=\"tableData.filteredRowsCount != tableData.totalRowsCount\">\n        {{tableData.filteredRowsCount}} rows filtered on {{tableData.totalRowsCount}}\n      </ng-container>\n      <ng-container *ngIf=\"tableData.filteredRowsCount === tableData.totalRowsCount\">\n        {{tableData.filteredRowsCount}}\n      </ng-container>\n      rows\n    </div>\n    <div class=\"pagination-buttons\" *ngIf=\"tableData.totalRowsCount > tableData.pageSize\">\n      <div [class]=\"tableData.splashMessageFlag ? 'splash-message show' : 'splash-message hide'\">\n        <div class=\"message-content\">{{tableData.splashMessageContent}}</div>\n      </div>\n      <div class=\"btn btnGroup btn-group\">\n        <button class=\"btn big\" [class]=\"tableData.page === 1 ? 'btn big btn-secondary ' : 'btn big btn-secondary '\"\n          (click)=\"changePage(1)\">First</button>\n        <button class=\"btn\" [class]=\"'btn btn-secondary'\" (click)=\"changePage(tableData.page - 1)\">&lt;</button>\n        <ng-container *ngFor=\"let pageNumber of pageNumbers()\">\n          <button class=\"btn\" [class]=\"tableData.page === pageNumber ? 'btn btn-primary ' : 'btn btn-secondary '\"\n            (click)=\"changePage(pageNumber)\">{{pageNumber}}</button>\n        </ng-container>\n        <button class=\"btn\" [class]=\"'btn btn-secondary'\" (click)=\"changePage(tableData.page + 1)\">&gt;</button>\n        <button class=\"btn big\"\n          [class]=\"tableData.page === tableData.totalPagesCount() ? 'btn big btn-secondary ' : 'btn big btn-secondary '\"\n          (click)=\"changePage(tableData.totalPagesCount())\">Last</button>\n      </div>\n    </div>\n  </div>\n</div>",
                    styles: [":host .tree-table{margin-top:10px;margin-bottom:10px;overflow:auto;position:relative}:host .tree-table .select-page-size{display:inline-block;width:auto}:host .tree-table .extraInfo-section .extraInfo{float:left}:host .tree-table table{width:100%;text-align:center;border-collapse:collapse;margin-bottom:5px}:host .tree-table table th{cursor:pointer;-moz-user-select:none;user-select:none;-ms-user-select:none;-webkit-user-select:none;font-weight:700}:host .tree-table table .expanded-row-content{background:0 0}:host .tree-table table tr>td:first-child.not-used,:host .tree-table table tr>th:first-child.not-used{display:none}:host .tree-table table tr>td:first-child.used,:host .tree-table table tr>th:first-child.used{width:50px}:host .tree-table table tr>td:first-child.used .collapsed-row-button:after,:host .tree-table table tr>th:first-child.used .collapsed-row-button:after{content:\"\";width:0;height:0;border-top:5px solid transparent;border-bottom:5px solid transparent;border-left:5px solid #fff;display:inline-block}:host .tree-table table tr>td:first-child.used .expanded-row-button:after,:host .tree-table table tr>th:first-child.used .expanded-row-button:after{content:\"\";width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:5px solid #fff;display:inline-block}:host .tree-table table tbody td button.popup-link-button{border-style:none!important;background:0 0!important;color:#86adef!important}:host .tree-table table tr .tt-row-action{margin-right:5px}:host .tree-table .column-visibility{text-align:center}:host .tree-table .column-visibility .btnVis,:host .tree-table .dropDownBtn-data .btnVis{border-style:none;padding:7px;border-radius:2px;margin-right:5px;margin-bottom:5px}:host .tree-table .column-visibility .btnVis.active,:host .tree-table .column-visibility .btnVis:hover,:host .tree-table .dropDownBtn-data .btnVis.active,:host .tree-table .dropDownBtn-data .btnVis:hover{background-color:#666;color:#fff}:host .tree-table .action-container .btn{margin-right:5px}:host .tree-table .action-container .search-section{overflow:visible;margin-top:10px;margin-bottom:5px}:host .tree-table .action-container .search-section .first-part{width:40%;float:left;text-align:left;display:inline-block}:host .tree-table .action-container .search-section .second-part{width:60%;display:inline-block}:host .table-bottom{overflow:auto}:host .table-bottom .page-number-status{float:left;overflow:auto;padding-top:.375rem}:host .table-bottom .btnGroup{float:right;padding-right:0;padding-top:0;padding-bottom:0}:host .table-bottom .pagination-buttons{overflow:auto;position:relative}:host .table-bottom .pagination-buttons .splash-message{float:right;position:absolute;right:0;z-index:9999;background:#ececec;border-radius:3px;color:#86adef;font-weight:700;padding:5.5px 15px;transition:opacity 1s ease-in-out}:host .table-bottom .pagination-buttons .splash-message.show{opacity:1}:host .table-bottom .pagination-buttons .splash-message.hide{padding:0;opacity:0}:host .table-bottom .pagination-buttons button{width:48px}:host .table-bottom .pagination-buttons button.big{width:50px}:host .tree-table-loading{width:100%;background-color:rgba(0,0,0,.5);overflow:auto;position:absolute}:host .tree-table-loading .loader-msg{color:#fff;font-weight:700;text-align:center;width:100%;height:100px;position:absolute;top:calc(50% - 50px)}:host .tree-table-loading.on{height:100%;z-index:1000}:host .tree-table-loading.off{height:0%}:host .dropDownBtn-data{overflow:visible;padding:5px}"]
                }] }
    ];
    /** @nocollapse */
    AngularTreeTableComponent.ctorParameters = function () { return [
        { type: KeyValueDiffers }
    ]; };
    AngularTreeTableComponent.propDecorators = {
        tableData: [{ type: Input }],
        rowSelectionChanged: [{ type: Output }]
    };
    return AngularTreeTableComponent;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    AngularTreeTableComponent.prototype.dataDiffers;
    /** @type {?} */
    AngularTreeTableComponent.prototype.tableData;
    /** @type {?} */
    AngularTreeTableComponent.prototype.filteredData;
    /** @type {?} */
    AngularTreeTableComponent.prototype.className;
    /** @type {?} */
    AngularTreeTableComponent.prototype.randomInstance;
    /** @type {?} */
    AngularTreeTableComponent.prototype.dropdownHideListenerAdded;
    /** @type {?} */
    AngularTreeTableComponent.prototype.currentPageData;
    /**
     * @type {?}
     * @private
     */
    AngularTreeTableComponent.prototype.columnFiltersDiffers;
    /** @type {?} */
    AngularTreeTableComponent.prototype.json;
    /** @type {?} */
    AngularTreeTableComponent.prototype.extraInfoItemWidthPercent;
    /** @type {?} */
    AngularTreeTableComponent.prototype.rowSelectionChanged;
    /**
     * @type {?}
     * @private
     */
    AngularTreeTableComponent.prototype.differs;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularTreeTableModule = /** @class */ (function () {
    function AngularTreeTableModule() {
    }
    AngularTreeTableModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [AngularTreeTableComponent],
                    imports: [
                        FormsModule,
                        CommonModule
                    ],
                    exports: [
                        AngularTreeTableComponent
                    ]
                },] }
    ];
    return AngularTreeTableModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TreeTableHeaderObject = /** @class */ (function () {
    function TreeTableHeaderObject(title, dataProperty, style, show) {
        this.dataType = TtDataType.TEXT;
        this.enableColumnSearch = true; //It will take effect when column search is enabled in data
        this.dataProperty = dataProperty;
        this.title = title;
        this.style = style;
        this.show = show;
    }
    return TreeTableHeaderObject;
}());
if (false) {
    /** @type {?} */
    TreeTableHeaderObject.prototype.dataProperty;
    /** @type {?} */
    TreeTableHeaderObject.prototype.title;
    /** @type {?} */
    TreeTableHeaderObject.prototype.style;
    /** @type {?} */
    TreeTableHeaderObject.prototype.show;
    /** @type {?} */
    TreeTableHeaderObject.prototype.dataType;
    /** @type {?} */
    TreeTableHeaderObject.prototype.enableColumnSearch;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TreeTableRowAction = /** @class */ (function () {
    function TreeTableRowAction(label, title, classes, action) {
        this.type = TreeTableRowActionType.BUTTON;
        this.label = label;
        this.title = title;
        this.classes = classes;
        this.action = action;
    }
    return TreeTableRowAction;
}());
if (false) {
    /** @type {?} */
    TreeTableRowAction.prototype.label;
    /** @type {?} */
    TreeTableRowAction.prototype.title;
    /** @type {?} */
    TreeTableRowAction.prototype.classes;
    /** @type {?} */
    TreeTableRowAction.prototype.action;
    /** @type {?} */
    TreeTableRowAction.prototype.type;
    /** @type {?} */
    TreeTableRowAction.prototype.context;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AngularTreeTableComponent, AngularTreeTableModule, AngularTreeTableService, TreeTableData, TreeTableHeaderObject, TreeTableRow, TreeTableRowAction, TreeTableRowActionType, TtDataType };
//# sourceMappingURL=angular-tree-table.js.map
